<template>
  <div id="components-form-demo-advanced-search">
    <a-form
      :form="form"
      @submit="handleSearch"
      class="ant-advanced-search-form"
    >
      <a-row :gutter="24">
        <a-col :md="8" :sm="24">
          <a-form-item
            :label-col="{ span: 6 }"
            :wrapper-col="{ span: 18 }"
            label="By name: "
          >
            <a-input
              v-decorator="[
                'name',
                {
                  rules: [{
                    required: false,
                    message: 'Opps!!!',
                  }],
                }
              ]"
              placeholder="Name"
            />
          </a-form-item>
        </a-col>
        <a-col :md="8" :sm="24">
          <a-form-item
            :label-col="{ span: 6 }"
            :wrapper-col="{ span: 18 }"
            label="By status: "
          >
            <a-select
              :get-popup-container="triggerNode => triggerNode.parentNode"
              placeholder="status"
              default-value="0"
            >
              <a-select-option value="0">
                AVAILABLE
              </a-select-option>
              <a-select-option value="1">
                SOLDOUT
              </a-select-option>
              <a-select-option value="2">
                DISABLED
              </a-select-option>
            </a-select>
          </a-form-item>
        </a-col>
        <template v-if="expand">
          <a-col :md="8" :sm="24">
            <a-form-item
              :label-col="{ span: 6 }"
              :wrapper-col="{ span: 18 }"
              label="Description: "
            >
              <a-input
                v-decorator="[
                  'description',
                  {
                    rules: [{
                      required: false,
                      message: 'Opps!!!',
                    }],
                  }
                ]"
                placeholder="Description"
              />
            </a-form-item>
          </a-col>
          <a-col :md="8" :sm="24">
            <a-form-item
              :label-col="{ span: 6 }"
              :wrapper-col="{ span: 18 }"
              label="By DateTime: "
            >
              <a-date-picker style="width: 100%" placeholder="Date Time" />
            </a-form-item>
          </a-col>
          <a-col :md="8" :sm="24">
            <a-form-item
              :label-col="{ span: 6 }"
              :wrapper-col="{ span: 18 }"
              label="Location: "
            >
              <a-input
                v-decorator="[
                  'location',
                  {
                    rules: [{
                      required: false,
                      message: 'Opps!!!',
                    }],
                  }
                ]"
                placeholder="Location"
              />
            </a-form-item>
          </a-col>
          <a-col :md="8" :sm="24">
            <a-form-item
              :label-col="{ span: 6 }"
              :wrapper-col="{ span: 18 }"
              label="Price: "
            >
              <a-input
                v-decorator="[
                  'price',
                  {
                    rules: [{
                      required: false,
                      message: 'Opps!!!',
                    }],
                  }
                ]"
                placeholder="Price"
              />
            </a-form-item>
          </a-col>
        </template>
        <a-col
          :span="(expand && 24) || 8"
          :style="{ textAlign: 'right' }"
        >
          <a-button
            type="primary"
            html-type="submit"
          >
            Apply
          </a-button>
          <a-button
            :style="{ marginLeft: '8px' }"
            @click="handleReset"
          >
            Clear
          </a-button>
          <a
            :style="{ marginLeft: '8px', fontSize: '12px' }"
            @click="toggleExpand"
          >
            Expand <a-icon :type="expand ? 'up' : 'down'" />
          </a>
        </a-col>
      </a-row>
    </a-form>
  </div>
</template>
<script>

export default {
  data () {
    return {
      expand: false,
      form: this.$form.createForm(this)
    }
  },
  computed: {
    count () {
      return this.expand ? 11 : 7
    }
  },
  methods: {
    toggleExpand () {
      this.expand = !this.expand
    },

    handleSearch (e) {
      e.preventDefault()
      this.form.validateFields((error, values) => {
        console.log('error', error)
        console.log('Received values of form: ', values)
      })
    },

    handleReset () {
      this.form.resetFields()
    },

    toggle () {
      this.expand = !this.expand
    }
  }
}
</script>
<style>
.ant-advanced-search-form {
  padding: 8px;
}

.ant-advanced-search-form .ant-form-item {
  display: flex;
}

.ant-advanced-search-form .ant-form-item-control-wrapper {
  flex: 1;
}

#components-form-demo-advanced-search .ant-form {
  max-width: none;
}
</style>
